package com.ejie.ad74a.control;

import java.text.ParseException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.propertyeditors.CustomDateEditor;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.ServletRequestDataBinder;
import org.springframework.web.bind.annotation.InitBinder;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.multipart.support.ByteArrayMultipartFileEditor;

import com.ejie.ad74a.model.DatosTareaEstudio;
import com.ejie.ad74a.model.DatosTareaEstudioAlta;
import com.ejie.ad74a.model.DatosTareaEstudioBaja;
import com.ejie.ad74a.model.DatosTareaEstudioInforme;
import com.ejie.ad74a.model.DatosTareaEstudioModDireccion;
import com.ejie.ad74a.model.DatosTareaEstudioRevision;
import com.ejie.ad74a.model.Dependencia;
import com.ejie.ad74a.model.Discapacidad;
import com.ejie.ad74a.model.DocumentosTarea;
import com.ejie.ad74a.model.Expedientes;
import com.ejie.ad74a.model.Iprem;
import com.ejie.ad74a.model.TareasTramite;
import com.ejie.ad74a.model.TramiteTareaDto;
import com.ejie.ad74a.model.TramitesExpediente;
import com.ejie.ad74a.service.DependenciaService;
import com.ejie.ad74a.service.DiscapacidadService;
import com.ejie.ad74a.service.ExpedientesService;
import com.ejie.ad74a.service.IpremService;
import com.ejie.ad74a.service.TareasTramiteService;
import com.ejie.ad74a.service.TramitesExpedienteService;
import com.ejie.ad74a.service.tramitacion.TareaEstudioDocumentacionService;
import com.ejie.ad74a.util.comun.UtilSeguridad;
import com.ejie.ad74a.util.comun.Utilidades;
import com.ejie.ad74a.util.constantes.Constantes;
import com.ejie.ad74a.util.constantes.ProcedimientosEnum;
import com.ejie.ad74a.util.constantes.TareasEnum;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;
import com.ejie.x38.util.DateTimeManager;

/**
 * TramitesExpedienteController generated by UDA, 03-may-2023 9:38:21.
 * 
 * @author UDA
 */

@Controller
@RequestMapping(value = "/tramitesexpediente")

public class TramitesExpedienteController {

	private static final Logger logger = LoggerFactory.getLogger(TramitesExpedienteController.class);

	@Autowired
	private TramitesExpedienteService tramitesExpedienteService;

	@Autowired
	private TareasTramiteService tareasTramiteService;

	@Autowired
	private TareaEstudioDocumentacionService tareaEstudioDocumentacionService;

	@Autowired
	private ExpedientesService expedientesService;

	@Autowired
	private DependenciaService dependenciaService;

	@Autowired
	private DiscapacidadService discapacidadService;

	@Autowired
	private IpremService ipremService;

	@InitBinder
	protected void initBinder(HttpServletRequest request, ServletRequestDataBinder binder) throws ServletException {
		binder.registerCustomEditor(byte[].class, new ByteArrayMultipartFileEditor());
		binder.registerCustomEditor(Date.class,
				new CustomDateEditor(DateTimeManager.getDateTimeFormat(LocaleContextHolder.getLocale()), true));
	}

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idTramiteExp10 BigDecimal
	 * @return TramitesExpediente Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/{idTramiteExp10}", method = RequestMethod.GET)
	public @ResponseBody TramitesExpediente get(@PathVariable Long idTramiteExp10) {
		TramitesExpediente tramitesExpediente = new TramitesExpediente();
		tramitesExpediente.setIdTramiteExp10(idTramiteExp10);
		tramitesExpediente = this.tramitesExpedienteService.find(tramitesExpediente);
		TramitesExpedienteController.logger.info("[GET - findBy_PK] : Obtener TramitesExpediente por PK");
		return tramitesExpediente;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterTramitesExpediente TramitesExpediente Objeto que contiene los
	 *                                 parametros de filtrado utilizados en la
	 *                                 busqueda.
	 * @return List<TramitesExpediente> Lista de objetos correspondientes a la
	 *         busqueda realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<TramitesExpediente> getAll(@ModelAttribute TramitesExpediente filterTramitesExpediente) {
		TramitesExpedienteController.logger.info("[GET - find_ALL] : Obtener TramitesExpediente por filtro");
		return this.tramitesExpedienteService.findAll(filterTramitesExpediente, null);
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param tramitesExpediente TramitesExpediente Bean que contiene la informacion
	 *                           a modificar.
	 * @return TramitesExpediente Bean resultante de la modificacion.
	 */
	@RequestMapping(value = "/edit", method = RequestMethod.PUT)
	public @ResponseBody TramitesExpediente edit(@RequestBody TramitesExpediente tramitesExpediente) {
		TramitesExpediente tramitesExpedienteAux = this.tramitesExpedienteService.update(tramitesExpediente);
		TramitesExpedienteController.logger.info("[PUT] : TramitesExpediente actualizado correctamente");
		return tramitesExpedienteAux;
	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param tramitesExpediente TramitesExpediente Bean que contiene la informacion
	 *                           con la que se va a crear el nuevo registro.
	 * @return TramitesExpediente Bean resultante del proceso de creacion.
	 */
	@RequestMapping(value = "/add", method = RequestMethod.POST)
	public @ResponseBody TramitesExpediente add(@RequestBody TramitesExpediente tramitesExpediente) {
		TramitesExpediente tramitesExpedienteAux = this.tramitesExpedienteService.add(tramitesExpediente);
		TramitesExpedienteController.logger.info("[POST] : TramitesExpediente insertado correctamente");
		return tramitesExpedienteAux;
	}

	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al identificador
	 * especificado.
	 *
	 * @param idTramiteExp10 BigDecimal Identificador del objeto que se desea
	 *                       eliminar.
	 * @return TramitesExpediente Bean eliminado.
	 */
	@RequestMapping(value = "/{idTramiteExp10}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody TramitesExpediente remove(@PathVariable Long idTramiteExp10) {
		TramitesExpediente tramitesExpediente = new TramitesExpediente();
		tramitesExpediente.setIdTramiteExp10(idTramiteExp10);
		this.tramitesExpedienteService.remove(tramitesExpediente);
		TramitesExpedienteController.logger.info("[DELETE] : TramitesExpediente borrado correctamente");
		return tramitesExpediente;
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 * 
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @param model Model
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit(Model model) {
		TramitesExpedienteController.logger.info("[GET - View] : tramitesexpediente");
		model.addAttribute("tramitesexpediente", new TramitesExpediente());
		return "tramitesexpediente";
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterTramitesExpediente TramitesExpediente Bean que contiene los
	 *                                 parametros de filtrado a emplear.
	 * @param tableRequestDto          Dto que contiene los parametros de
	 *                                 configuracion propios del RUP_TABLE a aplicar
	 *                                 en el filtrado.
	 * @return TableResponseDto<TramitesExpediente> Dto que contiene el resultado
	 *         del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<TramitesExpediente> filter(
			@RequestJsonBody(param = "filter") TramitesExpediente filterTramitesExpediente,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		TramitesExpedienteController.logger.info("[POST - filter] : Obtener TramitesExpedientes");
		return this.tramitesExpedienteService.filter(filterTramitesExpediente, tableRequestDto, false);
	}

	/**
	 * Operacion de busqueda del componente RUP_TABLE.
	 * 
	 * @param filterTramitesExpediente TramitesExpediente Bean que contiene los
	 *                                 parametros de filtrado a emplear.
	 * @param searchTramitesExpediente TramitesExpediente Bean que contiene los
	 *                                 parametros de busqueda a emplear.
	 * @param tableRequestDto          Dto que contiene los parametros de
	 *                                 configuracion propios del RUP_TABLE a aplicar
	 *                                 en la búsqueda.
	 * @return TableRowDto<TramitesExpediente> Dto que contiene el resultado de la
	 *         busqueda realizada por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/search", method = RequestMethod.POST)
	public @ResponseBody List<TableRowDto<TramitesExpediente>> search(
			@RequestJsonBody(param = "filter") TramitesExpediente filterTramitesExpediente,
			@RequestJsonBody(param = "search") TramitesExpediente searchTramitesExpediente,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		TramitesExpedienteController.logger.info("[POST - search] : Buscar TramitesExpedientes");
		return this.tramitesExpedienteService.search(filterTramitesExpediente, searchTramitesExpediente,
				tableRequestDto, false);
	}

	/**
	 * Borrado multiple de registros
	 * 
	 * @param filterTramitesExpediente TramitesExpediente Bean que contiene los
	 *                                 parametros de filtrado a emplear.
	 * @param tableRequestDto          Dto que contiene los parametros de
	 *                                 configuracion propios del RUP_TABLE a aplicar
	 *                                 en la busqueda.
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 * 
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody List<String> removeMultiple(@RequestJsonBody TableRequestDto tableRequestDto) {
		TramitesExpedienteController.logger.info("[POST - removeMultiple] : Eliminar multiples TramitesExpedientes");
		this.tramitesExpedienteService.removeMultiple(tableRequestDto);
		TramitesExpedienteController.logger.info("All entities correctly deleted!");

		return tableRequestDto.getMultiselection().getSelectedIds();
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE - JERARQUIA
	 */

	/**
	 * Operacion de filtrado del componente RUP_TABLE para presentar los registros
	 * mediante visualizacion jerarquica.
	 * 
	 * @param filterTramitesExpediente TramitesExpediente Bean que contiene los
	 *                                 parametros de filtrado a emplear.
	 * @param tableRequestDto          Dto que contiene los parametros de
	 *                                 configuracion propios del RUP_TABLE a aplicar
	 *                                 en el filtrado.
	 * @return TableResponseDto<JerarquiaDto<TramitesExpediente>> Dto que contiene
	 *         el resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquia/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<JerarquiaDto<TramitesExpediente>> jerarquia(
			@RequestJsonBody(param = "filter") TramitesExpediente filterTramitesExpediente,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		TramitesExpedienteController.logger.info("[POST - jerarquia] : Obtener TramitesExpedientes jerarquia");
		return this.tramitesExpedienteService.jerarquia(filterTramitesExpediente, tableRequestDto, false);
	}

	/**
	 * Recupera los hijos de los registros desplegados en la visualizacion
	 * jerarquica.
	 * 
	 * @param filterTramitesExpediente TramitesExpediente Bean que contiene los
	 *                                 parametros de filtrado a emplear.
	 * @param tableRequestDto          Dto que contiene los parametros de
	 *                                 configuracion propios del RUP_TABLE a aplicar
	 *                                 en el filtrado.
	 * @return TableResponseDto<JerarquiaDto<TramitesExpediente>> Dto que contiene
	 *         el resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquiaChildren", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<JerarquiaDto<TramitesExpediente>> jerarquiaChildren(
			@RequestJsonBody(param = "filter") TramitesExpediente filterTramitesExpediente,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		TramitesExpedienteController.logger.info("[POST - jerarquia] : Obtener TramitesExpedientes jerarquia - Hijos");
		return this.tramitesExpedienteService.jerarquiaChildren(filterTramitesExpediente, tableRequestDto);
	}

	/**
	 * EXPORTERS
	 */
	/**
	 * Devuelve los datos exportados de la tabla y los copia al Portapapeles.
	 *
	 * @param filterTramitesExpediente TramitesExpediente
	 * @param tableRequestDto          TableRequestDto
	 */
	@RequestMapping(value = "/clipboardReport", method = RequestMethod.POST)
	protected @ResponseBody List<TramitesExpediente> getClipboardReport(
			@RequestJsonBody(param = "filter") TramitesExpediente filterTramitesExpediente,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		TramitesExpedienteController.logger.info("[POST - clipboardReport] : : Copiar en Portapapeles");
		return this.tramitesExpedienteService.getMultiple(filterTramitesExpediente, tableRequestDto, false);
	}

	/**
	 * Devuelve un fichero excel que contiene los datos exportados de la tabla.
	 *
	 * @param filter          TramitesExpediente
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = { "/xlsReport",
			"/xlsxReport" }, method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	protected @ResponseBody void generateExcelReport(
			@RequestJsonBody(param = "filter", required = false) TramitesExpediente filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request, HttpServletResponse response)
			throws ServletException {
		TramitesExpedienteController.logger.info("[POST - generateExcelReport] : Devuelve un fichero excel");

		this.tramitesExpedienteService.generateReport(filter, columns, columnsName, fileName, sheetTitle,
				tableRequestDto, request, response);
	}

	/**
	 * Devuelve un fichero pdf que contiene los datos exportados de la tabla.
	 *
	 * @param filter          TramitesExpediente
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = "pdfReport", method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	protected @ResponseBody void generatePDFReport(
			@RequestJsonBody(param = "filter", required = false) TramitesExpediente filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		TramitesExpedienteController.logger.info("[POST - generatePDFReport] : Devuelve un fichero pdf");

		this.tramitesExpedienteService.generateReport(filter, columns, columnsName, fileName, sheetTitle,
				tableRequestDto, request, response);
	}

	/**
	 * Devuelve un fichero ods que contiene los datos exportados de la tabla.
	 *
	 * @param filter          TramitesExpediente
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = "odsReport", method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	protected @ResponseBody void generateODSReport(
			@RequestJsonBody(param = "filter", required = false) TramitesExpediente filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		TramitesExpedienteController.logger.info("[POST - generateODSReport] : Devuelve un fichero ods");

		this.tramitesExpedienteService.generateReport(filter, columns, columnsName, fileName, sheetTitle,
				tableRequestDto, request, response);
	}

	/**
	 * Devuelve un fichero csv que contiene los datos exportados de la tabla.
	 *
	 * @param filter          TramitesExpediente
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = "csvReport", method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	protected @ResponseBody void generateCSVReport(
			@RequestJsonBody(param = "filter", required = false) TramitesExpediente filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		TramitesExpedienteController.logger.info("[POST - generateCSVReport] : Devuelve un fichero csv");

		this.tramitesExpedienteService.generateReport(filter, columns, columnsName, fileName, sheetTitle,
				tableRequestDto, request, response);
	}

	@RequestMapping(value = "getTrEstudioDoc", method = RequestMethod.POST)
	public @ResponseBody TramiteTareaDto getTrEstudioDoc(
			@RequestJsonBody(param = "tramiteTareaDtoFilter") TramiteTareaDto tramiteTareaDtoFilter, Model model)
			throws ParseException {

		TramiteTareaDto tramiteTareaDto = new TramiteTareaDto();
		tramiteTareaDto.setIdTarea(tramiteTareaDtoFilter.getIdTarea());
		TramitesExpediente tramitesExpediente = this.tramitesExpedienteService
				.find(tramiteTareaDtoFilter.getTramitesExpediente());
		tramiteTareaDto.setTramitesExpediente(tramitesExpediente);

		if (tramitesExpediente != null) {
			Expedientes expediente = new Expedientes(tramitesExpediente.getIdExpediente10());
			expediente = this.expedientesService.find(expediente);

			if (expediente != null) {

				// Por defecto la fecha resolucion tiene que ser la actual. Si es null seteamos
				// la actual
				if (expediente.getfResolucion00() == null) {
					expediente.setfResolucion00(Calendar.getInstance().getTime());
				}
				// Por defecto la resolucion de la exención va a no

				if (expediente.getExencionRes00() == null) {
					expediente.setExencionRes00(Constantes.VAL_NUM_NO);
				}

				tramitesExpediente.setExpediente(expediente);

				// Seteamos las dependecias
				Dependencia depFilter = new Dependencia();
				depFilter.setIdExpediente04(expediente.getIdExpediente00());
				tramitesExpediente.setDependencias(dependenciaService.findByIdExp(depFilter));

				// Seteamos las dependecias
				Discapacidad disFilter = new Discapacidad();
				disFilter.setIdExpediente71(expediente.getIdExpediente00());
				tramitesExpediente.setDiscapacidad(discapacidadService.findByIdExp(disFilter));

				TareasTramite tareasTramite = new TareasTramite();
				tareasTramite.setTramitesExpediente(new TramitesExpediente(tramitesExpediente.getIdTramiteExp10()));
				List<TareasTramite> listaTareasTramite = tareasTramiteService.findAll(tareasTramite, null);

				if (tareasTramite != null && tareasTramite.getDatosTareaEstudioBaja() != null
						&& tareasTramite.getDatosTareaEstudioBaja().getfConcesionBaja() == null) {
					tareasTramite.getDatosTareaEstudioBaja().setfConcesionBaja(Calendar.getInstance().getTime());
				}

				if (listaTareasTramite != null && listaTareasTramite.size() == 1) {

					tareasTramite = listaTareasTramite.get(0);

					if (tramiteTareaDto.getTramitesExpediente().getExpediente().getIdProcedimiento00()
							.equalsIgnoreCase(ProcedimientosEnum.ALTA.getId())) {

						if (tramiteTareaDto.getDatosTarea() != null
								&& tramiteTareaDto.getDatosTarea().getIdTarea() != null
								&& tramiteTareaDto.getDatosTarea().getIdTarea().equals(TareasEnum.ESTUDIO.getId())) {
							// Por defecto el tipoPrecio se pone público en el datos Tarea estudio alta
							if ((tareasTramite.getDatosTareaEstudio() != null
									&& tareasTramite.getDatosTareaEstudioAlta().getTipoPrecio() == null)) {
								tareasTramite.getDatosTareaEstudioAlta().setTipoPrecio(Constantes.TIPOPRECIO_PUBLICO);
							}

						}
						if (tareasTramite.getDatosTarea() == null) {
							tramiteTareaDto.setTipoPrecio(Constantes.TIPOPRECIO_PUBLICO);
							Iprem maxIprem = ipremService.getMaxIprem();
							if (maxIprem != null && maxIprem.getAnio79() != null) {
								tramiteTareaDto.getTramitesExpediente().setAnioIPREM(maxIprem.getAnio79().toString());
							}

						}

					} else if (tramiteTareaDto.getTramitesExpediente().getExpediente().getIdProcedimiento00()
							.equalsIgnoreCase(ProcedimientosEnum.BAJA.getId())) {
						if (tareasTramite.getDatosTarea() == null) {
							tramiteTareaDto.setfConcesionBaja(expediente.getfBaja00());
							tramiteTareaDto.setfDenegacionBaja(Calendar.getInstance().getTime());
						}

					} else if (tramiteTareaDto.getTramitesExpediente().getExpediente().getIdProcedimiento00()
							.equalsIgnoreCase(ProcedimientosEnum.INFORME.getId())) {
						if (tareasTramite.getDatosTarea() == null) {
							tramiteTareaDto.setfRechazoInforme(Calendar.getInstance().getTime());
							tramiteTareaDto.setfSolInforme(Calendar.getInstance().getTime());
							tramiteTareaDto.setfSubsanacion(Calendar.getInstance().getTime());
						}

					} else if (tramiteTareaDto.getTramitesExpediente().getExpediente().getIdProcedimiento00()
							.equalsIgnoreCase(ProcedimientosEnum.MODIFICACION.getId())) {
						if (tareasTramite.getDatosTarea() == null) {
							tramiteTareaDto.setfCambio(Calendar.getInstance().getTime());
							tramiteTareaDto.setfSubsanacion(Calendar.getInstance().getTime());
						}

					} else if (tramiteTareaDto.getTramitesExpediente().getExpediente().getIdProcedimiento00()
							.equalsIgnoreCase(ProcedimientosEnum.REVISION_PRECIO.getId())) {

						if (tareasTramite.getDatosTarea() == null) {
							tramiteTareaDto.setTipoPrecio(Constantes.TIPOPRECIO_PUBLICO);
							Iprem maxIprem = ipremService.getMaxIprem();

							tramiteTareaDto.getTramitesExpediente().setAnioIPREM(maxIprem.getAnio79().toString());

						}

					}

					HashMap<String, List<DocumentosTarea>> mapDoc = new HashMap<String, List<DocumentosTarea>>();
					mapDoc = tramitesExpedienteService.getDocumentListToStudyTask(expediente, tareasTramite,
							tareasTramite.getIdEstado11());

					if (tramiteTareaDto.getDatosTareaEstudio() != null) {
						tramiteTareaDto.getDatosTareaEstudio().setDocumentosAportados(
								Utilidades.listToJsonArray(mapDoc.get(Constantes.DOCUMENTOS_APORTADO)));
					} else {
						tramiteTareaDto.setDocumentosAportados(
								Utilidades.listToJsonArray(mapDoc.get(Constantes.DOCUMENTOS_APORTADO)));
					}

					tramitesExpediente.setTareaTramite(tareasTramite);

				}
			}

		}

		TramitesExpedienteController.logger.info(
				"[GET - findBy_idExpediente00&Tramite] : Obtener TramitesExpediente por idExpediente00 y tramite");

		return tramiteTareaDto;
	}

	@RequestMapping(value = "cambiarTecnico", method = RequestMethod.POST)
	public @ResponseBody String cambiarTecnico(@RequestJsonBody(param = "expediente") Expedientes expediente,
			HttpServletResponse response) throws ParseException {
		TramitesExpedienteController.logger
				.info("[GET - TramitesExpedienteController ] : cambiarTecnico Cambiar tecnico");
		expediente.setUsuModif00(UtilSeguridad.getUsuarioConectado().getUserName());
		this.expedientesService.updateTecnico(expediente);
		TramitesExpedienteController.logger
				.info("[GET - TramitesExpedienteController] : cambiarTecnico Cambiar Tecnico");

		return "ok";
	}

	@RequestMapping(value = "guardarTarea", method = RequestMethod.POST)
	public @ResponseBody String guardarTarea(
			@RequestJsonBody(param = "TramiteTareaDto") TramiteTareaDto tramiteTareaDto) {
		TramitesExpedienteController.logger.info("[POST - guardarTarea] : Obtener guardarTarea");

		List<DocumentosTarea> listaDocumentosAportados = new ArrayList<DocumentosTarea>();

		Long idExpediente = tramiteTareaDto.getTramitesExpediente().getExpediente().getIdExpediente00();

		Long codTareaTramite = tramiteTareaDto.getTramitesExpediente() != null
				&& tramiteTareaDto.getTramitesExpediente().getTareaTramite() != null
						? tramiteTareaDto.getTramitesExpediente().getTareaTramite().getIdTareaTram11()
						: null;
		Long codTramite = tramiteTareaDto.getTramitesExpediente() != null
				? tramiteTareaDto.getTramitesExpediente().getIdTramiteExp10()
				: null;

		DatosTareaEstudio datosTareaEstudio = null;
		if (tramiteTareaDto.getDatosTareaEstudio() != null && tramiteTareaDto.getDatosTareaEstudio()
				.getIdProcedimiento00().equalsIgnoreCase(ProcedimientosEnum.ALTA.getId())) {
			datosTareaEstudio = tramiteTareaDto.getDatosTareaEstudioAlta();
		} else if (tramiteTareaDto.getDatosTareaEstudio() != null && tramiteTareaDto.getDatosTareaEstudio()
				.getIdProcedimiento00().equalsIgnoreCase(ProcedimientosEnum.BAJA.getId())) {
			datosTareaEstudio = tramiteTareaDto.getDatosTareaEstudioBaja();
		} else if (tramiteTareaDto.getDatosTareaEstudio() != null && tramiteTareaDto.getDatosTareaEstudio()
				.getIdProcedimiento00().equalsIgnoreCase(ProcedimientosEnum.INFORME.getId())) {
			datosTareaEstudio = tramiteTareaDto.getDatosTareaEstudioInforme();
		} else if (tramiteTareaDto.getDatosTareaEstudio() != null && tramiteTareaDto.getDatosTareaEstudio()
				.getIdProcedimiento00().equalsIgnoreCase(ProcedimientosEnum.MODIFICACION.getId())) {
			datosTareaEstudio = tramiteTareaDto.getDatosTareaEstudioModDireccion();
		} else if (tramiteTareaDto.getDatosTareaEstudio() != null && tramiteTareaDto.getDatosTareaEstudio()
				.getIdProcedimiento00().equalsIgnoreCase(ProcedimientosEnum.REVISION_PRECIO.getId())) {
			datosTareaEstudio = tramiteTareaDto.getDatosTareaEstudioRevision();
		} else if (tramiteTareaDto.getDatosTareaEstudio() != null && tramiteTareaDto.getDatosTareaEstudio()
				.getIdProcedimiento00().equalsIgnoreCase(ProcedimientosEnum.REVISION_PRECIO.getId())) {
			datosTareaEstudio = tramiteTareaDto.getDatosTareaEstudioRevision();
		}

		Long situacioneFinalTarea = null;
		if (null != datosTareaEstudio && null != datosTareaEstudio.getSituacioneFinalTarea()) {
			situacioneFinalTarea = datosTareaEstudio.getSituacioneFinalTarea();
		}

		// Recuperamos la tarea que se va a actualizar y la poblamos con los datos
		// recuperados de presentación
		TareasTramite tareaUpdate = new TareasTramite();
		tareaUpdate.setIdTareaTram11(codTareaTramite);
		tareaUpdate = this.tareasTramiteService.find(tareaUpdate);
		if (null != situacioneFinalTarea) {
			tareaUpdate.setCodSituacion11(situacioneFinalTarea);
		}

		if (tramiteTareaDto.getTramitesExpediente().getExpediente().getIdProcedimiento00()
				.equalsIgnoreCase(ProcedimientosEnum.ALTA.getId())
				&& tramiteTareaDto.getDatosTareaEstudioAlta().getIdTarea().equals(TareasEnum.ESTUDIO.getId())) {
			tareaUpdate.setDatosTareaClobAlta((DatosTareaEstudioAlta) datosTareaEstudio);

		} else if (tramiteTareaDto.getTramitesExpediente().getExpediente().getIdProcedimiento00()
				.equalsIgnoreCase(ProcedimientosEnum.BAJA.getId())
				&& tramiteTareaDto.getDatosTareaEstudioBaja().getIdTarea().equals(TareasEnum.ESTUDIO.getId())) {
			tareaUpdate.setDatosTareaClobBaja((DatosTareaEstudioBaja) datosTareaEstudio);

		} else if (tramiteTareaDto.getTramitesExpediente().getExpediente().getIdProcedimiento00()
				.equalsIgnoreCase(ProcedimientosEnum.MODIFICACION.getId())
				&& tramiteTareaDto.getDatosTareaEstudioModDireccion().getIdTarea().equals(TareasEnum.ESTUDIO.getId())) {
			tareaUpdate.setDatosTareaClobModDireccion((DatosTareaEstudioModDireccion) datosTareaEstudio);

		} else if (tramiteTareaDto.getTramitesExpediente().getExpediente().getIdProcedimiento00()
				.equalsIgnoreCase(ProcedimientosEnum.INFORME.getId())
				&& tramiteTareaDto.getDatosTareaEstudioInforme().getIdTarea().equals(TareasEnum.ESTUDIO.getId())) {
			tareaUpdate.setDatosTareaClobInforme((DatosTareaEstudioInforme) datosTareaEstudio);

		} else if (tramiteTareaDto.getTramitesExpediente().getExpediente().getIdProcedimiento00()
				.equalsIgnoreCase(ProcedimientosEnum.REVISION_PRECIO.getId())
				&& tramiteTareaDto.getDatosTareaEstudioRevision().getIdTarea().equals(TareasEnum.ESTUDIO.getId())) {
			tareaUpdate.setDatosTareaClobRevision((DatosTareaEstudioRevision) datosTareaEstudio);

		}

		TramitesExpediente tramite = new TramitesExpediente();
		tramite.setIdTramiteExp10(codTramite);
		tramite = this.tramitesExpedienteService.find(tramite);

		// Seteamos las observaciones
		tramite.setObservaciones10(tramiteTareaDto.getTramitesExpediente().getObservaciones10());

		this.tareaEstudioDocumentacionService.tratarTareaEstudioDocumentacion(listaDocumentosAportados, idExpediente,
				tareaUpdate, tramite, tramiteTareaDto.getTipoTramite().equalsIgnoreCase("tramitar"));

		return "ok";
	}
}
